package cl.frn.pooseven;

import com.opencsv.bean.CsvBindByPosition;
import com.opencsv.bean.CsvCustomBindByPosition;
import com.opencsv.bean.CsvDate;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Objects;
import java.util.UUID;


public class AccessEvent {

    public enum AccessType {
        ALLOWED("Concedido"),
        DENIED("Denegado"),
        ENTRY("Entrada");

        private final String name;

        AccessType(String name) {
            this.name = name;
        }

        @Override
        public String toString() {
            return name;
        }

    }

//   public class Accsr extends AbstractBeanField   {
//        @Override
//        protected Object convert(String value) throws CsvDataTypeMismatchException, CsvConstraintViolationException {
////            return " Data.users.stream().filter(user1 -> user1.getId()==Integer.parseInt(value)).findFirst();";
//            return value;
//        }
//    }

    @CsvBindByPosition(position = 0)
    UUID id;
    @CsvCustomBindByPosition(position = 2, converter = UserConverter.class)
    User user;

    @CsvCustomBindByPosition(position = 3, converter = EventTypeConverter.class)
    AccessType type;

    @CsvDate()
    @CsvBindByPosition(position = 1)
    Date timestamp;

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }


    public void setId(UUID id) {
        this.id = id;
    }

    public void setType(AccessType type) {
        this.type = type;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }


    public UUID getId() {
        return id;
    }

    public String getName() {
        return user.getName();
    }

    public AccessType getType() {
        return type;
    }
    public int getTypeOrdinal() {
        return type.ordinal();
    }

    public Date getTimestamp() {
        return timestamp;
    }

    public String formattedDate(){
        SimpleDateFormat dt = new SimpleDateFormat("hh:mm:ss");

        return dt.format(timestamp);
    }

    @Override
    public String toString() {
        return STR."AccessEvent{id=\{id}, user=\{user}, type=\{type}, timestamp=\{timestamp}\{'}'}";
    }
    public String toCSV() {
        return STR."\{id},\{new SimpleDateFormat("yyyyMMdd'T'HHmmss").format(timestamp)},\{user.getId()},\{type.ordinal()}";
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        AccessEvent person = (AccessEvent) o;
        return getName().equals(person.getName());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getName());
    }
}
