package cl.frn.pooseven;

import io.github.palexdev.materialfx.controls.MFXButton;
import io.github.palexdev.materialfx.controls.MFXTableView;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.stage.Stage;

import java.io.IOException;
import java.net.URL;
import java.time.Instant;
import java.util.*;


public class AppController implements Initializable {


    MQTTController mqtt;
    AccessController accessController;
    SensorsController sensorsController;


    @FXML
    MFXTableView<AccessEvent> access_table;
    @FXML

    MFXTableView<User> users_table;

    @FXML
    MFXButton denyButton;
    @FXML
    MFXButton acceptButton;

    @FXML
    Label temp;

    @FXML
    MFXButton tempButton;


    @Override
    public void initialize(URL location, ResourceBundle resources) {
        mqtt = new MQTTController();
        accessController = new AccessController(this);
        sensorsController = new SensorsController(this);
        temp.textProperty().bind(sensorsController.temperatura);
        mqtt.connect();


        tempButton.setOnAction(_ -> {
            Parent root;
            try {
                root = FXMLLoader.load(Objects.requireNonNull(IotApp.class.getResource("sensor.fxml")));
                Stage stage = new Stage();
                stage.setTitle("Sensor");
                stage.setScene(new Scene(root));
                stage.show();
            } catch (IOException _) {

            }
        });

    }

    private static AppController instance;

    public static AppController getInstance() {
        if (instance == null) {
            instance = new AppController();
        }
        return instance;
    }

    @FXML
    Label welcomeText;

    @FXML
    void launchFakeAccess(){
        Parent root;
        try {
            root = FXMLLoader.load(Objects.requireNonNull(IotApp.class.getResource("access.fxml")));
            Stage stage = new Stage();
            stage.setTitle("Access");
            stage.setScene(new Scene(root));
            stage.show();
        } catch (IOException _) {

        }
    }



}

