package cl.frn.pooseven;

import com.opencsv.bean.CsvToBeanBuilder;
import javafx.collections.FXCollections;
import javafx.collections.ListChangeListener;
import javafx.collections.ObservableList;

import java.io.*;

public class Data {

    public static ObservableList<User> users;
    public static ObservableList<AccessEvent> accessEvents;

    public static void load() {
        readUsersFile();
        readLogFile();

        accessEvents.addListener((ListChangeListener<AccessEvent>) e -> {
            
            e.next();

            String fileName = "access_log.csv";

            FileWriter fw = null;
            try {
                fw = new FileWriter(fileName, true);
                BufferedWriter bw = new BufferedWriter(fw);
                bw.write( e.getAddedSubList().getFirst().toCSV());
                bw.newLine();
                bw.close();

            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }


        });
    }


    private static void readUsersFile() {
        try {
            String fileName = "users.csv";
            File f = new File(fileName);

            if (!f.exists()) {
                f.createNewFile();
            }

            users = FXCollections.observableArrayList(
                    new CsvToBeanBuilder(new FileReader(f))
                            .withType(User.class)
                            .build()
                            .parse());


        } catch (IOException e) {
            e.printStackTrace();
        }


    }

    private static void readLogFile() {
        try {

            String fileName = "access_log.csv";
            File f = new File(fileName);

            if (!f.exists()) {
                f.createNewFile();
                FileWriter fw = new FileWriter(f);
                fw.write("");
            }

            accessEvents = FXCollections.observableArrayList(
                    new CsvToBeanBuilder(new FileReader(f))
                            .withType(AccessEvent.class)
                            .build()
                            .parse());



            accessEvents.forEach(System.out::println);


        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
