package cl.frn.pooseven;

import io.github.palexdev.materialfx.controls.MFXButton;
import javafx.application.Platform;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import org.eclipse.paho.client.mqttv3.IMqttMessageListener;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.net.URL;
import java.util.ResourceBundle;

public class FakeDoorController implements Initializable {


    public static final String device_id = "fake-device";

    @FXML
    MFXButton btn;

    @FXML
    Label txt;
    @FXML
    TextField card;



    MqttClient client;


    @Override
    public void initialize(URL location, ResourceBundle resources) {
        try {
            client = new MqttClient(MQTTController.BROKER_URL, MqttClient.generateClientId(), new MemoryPersistence());
            client.connect();
        } catch (MqttException e) {
            e.printStackTrace();
        }

        btn.setOnAction(this::handle);
        try {
            client.subscribe(STR."device/\{device_id}/access/manage", new IMqttMessageListener() {
                @Override
                public void messageArrived(String topic, MqttMessage mqttMessage) throws Exception {
                        Platform.runLater(new Runnable(){
                            @Override
                            public void run() {
                                handleMqtt(mqttMessage.toString());
                            }
                        });
                    }
            });
        } catch (MqttException e) {
            e.printStackTrace();
        }

    }

    private void handleMqtt(String action) {
        if(action.equals("OPEN"))
            txt.setText("ABRIENDO PUERTA");
        else txt.setText("DENEGADO");
    }

    private void handle(ActionEvent e) {
        try {
            client.publish(STR."device/\{device_id}/access/request", new MqttMessage(card.getText().getBytes()));
            txt.setText("SOLICITANDO ACCESO...");
        } catch (MqttException ex) {
            ex.printStackTrace();
        }
    }
}