package cl.frn.pooseven;

import io.github.palexdev.materialfx.controls.MFXButton;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TextField;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.net.URL;
import java.util.ResourceBundle;
import java.util.Timer;

public class FakeSensorController implements Initializable {

    @FXML
    MFXButton btn;

    @FXML
    TextField txt;

    MqttClient client;

    Timer timer;
    @Override
    public void initialize(URL location, ResourceBundle resources) {
        try {
            client = new MqttClient(MQTTController.BROKER_URL, MqttClient.generateClientId(), new MemoryPersistence());
            client.connect();
        } catch (MqttException e) {
            e.printStackTrace();
        }

        btn.setOnAction(this::handle);
    }

    private void handle(ActionEvent e) {
        try {
            client.publish("device/fake-device/sensors/temp", new MqttMessage(txt.getText().getBytes()));
        } catch (MqttException ex) {
            ex.printStackTrace();
        }
    }
}