package cl.frn.pooseven;

import io.github.palexdev.materialfx.theming.JavaFXThemes;
import io.github.palexdev.materialfx.theming.MaterialFXStylesheets;
import io.github.palexdev.materialfx.theming.UserAgentBuilder;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Stage;

import java.io.IOException;

public class IotApp extends Application {
    @Override
    public void start(Stage stage) throws IOException {

        Data.load();

        FXMLLoader fxmlLoader = new FXMLLoader(IotApp.class.getResource("mainview.fxml"));
        Scene scene = new Scene(fxmlLoader.load());

//        // Create a MaterialFX ListView and add the items to it
//        MFXListView<String> listView = new MFXListView<>();
//        listView.setItems(items);
//
//        // Create a layout and add the ListView to it
//        StackPane root = new StackPane(listView);
//
//        // Create a scene with the layout
//
//        // Apply UserAgentBuilder to include themes
        UserAgentBuilder.builder()
                .themes(JavaFXThemes.MODENA)
                .themes(MaterialFXStylesheets.forAssemble(true)) // Adds MaterialFX's default theme, with legacy controls
                .setDeploy(true) // Deploy each theme's assets on a temporary dir on the disk
                .setResolveAssets(true) // Resolve @import statements and resources URLs
                .build() // Assemble all the added themes into a single CSSFragment
                .setGlobal(); // Set the produced stylesheet as the global User-Agent stylesheet



        stage.setScene(scene);
        stage.setTitle("MaterialFX Demo");
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
