package cl.frn.pooseven;

import org.eclipse.paho.client.mqttv3.*;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.util.ArrayList;
public class MQTTController {

    static class Subscription {
        String topic;

        IMqttMessageListener messageListener;
        Subscription(String topic,   IMqttMessageListener messageListener) {
            this.messageListener = messageListener;
            this.topic = topic;
        }


    }

    ArrayList<Subscription>subscriptions = new ArrayList<Subscription>();

    public static final String BROKER_URL = "tcp://localhost:1883";

    MqttClient client;


    MQTTController() {
    }


    void registerSubscription(Subscription subscription)   {
        this.subscriptions.add(subscription);
    }

    protected void connect() {
        try {
            client = new MqttClient(BROKER_URL, MqttClient.generateClientId(), new MemoryPersistence());
            client.setCallback(new MqttCallback() {
                @Override
                public void connectionLost(Throwable cause) {

                }

                @Override
                public void messageArrived(String topic, MqttMessage message) throws Exception {

                }

                @Override
                public void deliveryComplete(IMqttDeliveryToken token) {

                }
            });
            client.connect();

            subscribe();

        } catch (Exception e) {
            e.printStackTrace();

        }
    }

    private void sendMessage() {
        try {
            String message = "";
            if (!message.isEmpty()) {
                client.publish("sd", new MqttMessage(message.getBytes()));
            }
        } catch (MqttException e) {
            e.printStackTrace();
        }
    }
    void subscribe() throws MqttException {
        for(Subscription sub: subscriptions) {
            client.subscribe(sub.topic, sub.messageListener);
            System.out.println(STR."Subscribing\{sub.topic}");
        }
    }

    public void stop() throws Exception {
        if (client != null && client.isConnected()) {
            client.disconnect();
        }
    }
}
