from config import *
from machine import Pin, PWM
from time import sleep_ms
import machine


def scan_i2c():
    sdaPIN = Pin(SDA_PIN)
    sclPIN = Pin(SCK_PIN)
    i2c = machine.I2C(0, sda=sdaPIN, scl=sclPIN, freq=400000)
    devices = i2c.scan()
    if len(devices) != 0:
        print('Number of I2C devices found=', len(devices))
        for device in devices:
            print("Device Hexadecimel Address= ", hex(device))
    else:
        print("No device found")


def beep():
    if not BEEP_ENABLED:
        return
    if BUZZER_TYPE == BUZZER_TYPE_TONE:
        buzzer = PWM(Pin(BUZZER_PIN))
        buzzer.freq(BEEP_FREQ)
        buzzer.duty_ns(BUZZER_DUTY_CYCLE)
        sleep_ms(BEEP_DURATION)
        buzzer.duty_ns(0)
    elif BUZZER_TYPE == BUZZER_TYPE_STATIC:
        buzzer = Pin(BUZZER_PIN, Pin.OUT)
        buzzer.on()
        sleep_ms(BEEP_DURATION)
        buzzer.off()
