import lib.NFC_PN532 as nfc
from machine import Pin, SPI
from config import NFC_PIN, NFC_TIMEOUT


class rfid:
    def __init__(self):

        # SPI
        self.spi_dev = SPI(1, baudrate=1000000)
        self.cs = Pin(NFC_PIN, Pin.OUT)
        self.cs.on()

        # nfc lib
        self.pn532 = nfc.PN532(self.spi_dev, self.cs)
        ic, ver, rev, support = self.pn532.get_firmware_version()

        print('Found PN532 with firmware version: {0}.{1}'.format(ver, rev))

        # start
        self.pn532.SAM_configuration()

    def read(self):
        print('Reading...')
        uid = self.pn532.read_passive_target(timeout=NFC_TIMEOUT)
        # if uid is None:
        #     print('CARD NOT FOUND')
        # else:
        #     numbers = [i for i in uid]
        #     string_ID = '{}-{}-{}-{}'.format(*numbers)
        #     print('Found card with UID:', [hex(i) for i in uid])
        #     print('Number_id: {}'.format(string_ID))
        return uid
