# ELO329-2024-1-PRO-G7

## Integrantes

| Nombre             | Email              |
| ------------------ | ------------------ |
| Francisco González | fgonzalezmi@usm.cl |
| Karime Jarufe      | kjarufe@usm.cl     |

## Estructura del proyecto

```
ELO329-2024-1-PRO-G7
├── Doc
│  ├── ClassDiagram.png
│  ├── DiagramUML.puml
│  └── informe
│      ├── img
│      │  ├── ClassDiagram.png
│      │  ├── arquitectura.png
│      │  ├── logo.png
│      │  ├── sequence.drawio.png
│      │  ├── sequence0.drawio.png
│      │  └── sequence3.drawio.png
│      └── index.html
├── JavaApp # Codigo Aplicación en Java
│  ├── users.csv # lista de usuarios
│  ├── access_log.csv # registro de acceso
│  ├── mvnw
│  ├── mvnw.cmd
│  ├── pom.xml
│  ├── src
│  │  └── main
│  │      ├── java
│  │      │  ├── cl
│  │      │  │  └── frn
│  │      │  │      └── pooseven
│  │      │  │          ├── AccessController.java
│  │      │  │          ├── AccessEvent.java
│  │      │  │          ├── AppController.java
│  │      │  │          ├── Data.java
│  │      │  │          ├── EventTypeConverter.java
│  │      │  │          ├── FakeDoorController.java
│  │      │  │          ├── FakeSensorController.java
│  │      │  │          ├── IotApp.java
│  │      │  │          ├── MQTTController.java
│  │      │  │          ├── SensorsController.java
│  │      │  │          ├── User.java
│  │      │  │          └── UserConverter.java
│  │      │  └── module-info.java
│  │      └── resources
│  │          └── cl
│  │              └── frn
│  │                  └── pooseven
│  │                      ├── access.fxml
│  │                      ├── hello-view.fxml
│  │                      ├── mainview.fxml
│  │                      ├── sensor.fxml
│  │                      └── table.fxml
├── PicoW # Codigo microcontrolador
│  ├── src
│  │  ├── app.py
│  │  ├── config.py
│  │  ├── functions.py
│  │  ├── main.py
│  │  ├── rfid.py
```

## Compilación y ejecución

### JavaApp

```bash
$ mvn clean javafx:run # Esta instrucción descarga dependencias, compila y corre la aplicación.
```

### Servidor mqtt

[Instrucciones docker-mqtt](https://medium.com/@tomer.klein/docker-compose-and-mosquitto-mqtt-simplifying-broker-deployment-7aaf469c07ee)

#### Referencias

[MaterialFX](https://github.com/palexdev/MaterialFX)

### PicoW

Para correr la aplicación solo deben instalarse las librerías, subirse los archivos en el microcontrolador y reiniciarlo.

#### Librerías para el microcontrolador

- Cliente mqtt
  [umqtt.simple](https://github.com/micropython/micropython-lib/tree/master/micropython/umqtt.simple)

- Lector de tarjetas
  [RFID MRFC522](https://github.com/danjperron/micropython-mfrc522/blob/master/mfrc522.py)

- Sensor de temperatura
  [BMP280](https://docs.sunfounder.com/projects/umsk/en/latest/04_pi_pico/pico_start/04_upload_libraries.html#add-libraries-py)

#### Instrucciones para instalar librerías en el microcontrolador

```bash
> mip.install("http://direcciondelarchivo.py") # con url del las librerías indicadas anteriormente
# la instrucción anterior es suficiente para instalar las librerías en el microcontrolador.
```

## Descripción

## Uso

## MQTT-MESSAGE

Se detallan a continuación los mensajes mqtt que utiliza la aplicación y su estructura.

|                     | DESCRIPTION                                                                                                     | PUBLISHER     | SUBSCRIBER    | TOPIC                                   | MESSAGE        |
| ------------------- | --------------------------------------------------------------------------------------------------------------- | ------------- | ------------- | --------------------------------------- | -------------- |
| ABRIR/CERRAR ACCESO | Mensaje para abrir o cerrar un acceso                                                                           | APP           | ACCESS-DEVICE | /device/{device-id}/access/manage       | OPEN/CLOSE     |
| ESTADO DEL SENSOR   | Sensor envía su estado                                                                                          | SENSOR-DEVICE | APP           | /device/{device-id}/sensors/{sensor-id} | {sensor-value} |
| PETICIÓN DE ACCESO  | Lector de tarjeta o dispositivo de acceso envía la solicitud con id-usuario para ser autorizado a cierto acceso | ACCESS-DEVICE | APP           | /device/{device-id}/access/request      | {card-id}      |
